## nmap 7.95%2Bdfsg

=== zenmap/zenmapCore/data/locale/Makefile ===
LINGUAS = $(patsubst %.po,%,$(wildcard *.po))

TOPDIR = ../../..
SOURCEFILES = zenmap
SOURCEDIRS = zenmapCore zenmapGUI radialnet
PROFILE_EDITOR_XML = share/zenmap/misc/profile_editor.xml

XGETTEXT = xgettext
MSGID_BUGS_ADDRESS = dev@nmap.org

ZENMAP_POT = zenmap.pot
TMP_POT = tmp.pot

TMP_PO = tmp.po

all:
	@echo 'Run "make update-pot" to update $(ZENMAP_POT).'
	@echo 'Run "make <XX>.po" to update <XX>.po from $(ZENMAP_POT).'
	@echo 'Run "make update-mo" to update all MO files from PO files.'

update-pot:
	(echo $(SOURCEFILES); cd $(TOPDIR) && find $(SOURCEDIRS) -name '*.py') \
	  | $(XGETTEXT) -D $(TOPDIR) --from-code=utf-8 --language=python --msgid-bugs-address=$(MSGID_BUGS_ADDRESS) -f - -o $(TMP_POT)
	./xgettext-profile_editor.py -D $(TOPDIR) $(PROFILE_EDITOR_XML) >> $(TMP_POT)
	msguniq --to-code=utf-8 $(TMP_POT) | msgmerge -U --backup=none $(ZENMAP_POT) -
	rm -f $(TMP_POT)

update-mo: $(addsuffix /LC_MESSAGES/zenmap.mo,$(LINGUAS))

%.po: $(ZENMAP_POT)
	cp -f $@ $(TMP_PO)
	msgmerge -N $(TMP_PO) $< | msgattrib --no-obsolete -o $@
	rm -f $(TMP_PO)

%/LC_MESSAGES/zenmap.mo: %.po
	mkdir -p $*/LC_MESSAGES
	msgfmt $< -o $@

.PHONY: update-pot

=== debian/changelog ===
nmap (7.95+dfsg-3deepin1) unstable; urgency=medium

  * Disable LSX (-mlsx) on loong64 as it produces broken executables
    as of gcc-12 = 12.3.0-17deepin2.

 -- lichenggang <lichenggang@deepin.org>  Mon, 14 Apr 2025 18:21:28 +0800

nmap (7.95+dfsg-3) unstable; urgency=medium

  * Team upload.

  [ Stefano Rivera ]
  * Use pybuild's --name argument to separate builds.

  [ Sven Geuer ]
  * Add patch to fix incompatible pointer type error (Closes: #1100245).

 -- Sven Geuer <sge@debian.org>  Fri, 28 Mar 2025 19:00:38 +0100

nmap (7.95+dfsg-2) unstable; urgency=medium

  * Install zenmap icon (Closes: #1094394)

 -- Hilko Bengen <bengen@debian.org>  Sat, 01 Feb 2025 16:58:52 +0100

nmap (7.95+dfsg-1) unstable; urgency=medium

  * New upstream version 7.95+dfsg
  * Improve cross building: Demote python dependencies to B-D-I.
    Thanks to Helmut Grohne (Closes: #1086647)
  * Add python3-setuptools build-dependency (Closes: #1080676)
  * Rebase patches
  * Adjust for updated build scripts

 -- Hilko Bengen <bengen@debian.org>  Fri, 29 Nov 2024 13:13:42 +0000

## nmap 7.95+dfsg

=== macosx/Makefile ===
# This makefile builds a disk image (.dmg) containing the installer for Nmap,
# Zenmap, Ncat, and Ndiff.

export NMAP_VERSION := $(shell echo NMAP_VERSION | $(CPP) -imacros ../nmap.h - | sed -n '$$s/[" ]//g;$$p')
OSX_VERSION=$(shell sw_vers -productVersion | cut -d'.' -f1,2 | tr -d ' ')
OSX_MIN_VERSION = 10.15

NAME_VERSION = nmap-$(NMAP_VERSION)$(if $(APPENDAGE),-$(APPENDAGE))

IMAGE_NAME = $(NAME_VERSION).dmg
PKG_NAME = $(NAME_VERSION).mpkg

IMAGE_STAGING_DIR = $(NAME_VERSION)

NMAP_BUILD_DIR = nmap-build
NMAP_STAGING_DIR = nmap-root

ZENMAP_BUILD_DIR = zenmap-build
ZENMAP_STAGING_DIR = zenmap-root

NCAT_BUILD_DIR = ncat-build
NCAT_STAGING_DIR = ncat-root

NDIFF_BUILD_DIR = ndiff-build
NDIFF_STAGING_DIR = ndiff-root

NPING_BUILD_DIR = nping-build
NPING_STAGING_DIR = nping-root

JHBUILD_PREFIX=$(HOME)/gtk/inst
JHBUILD_SOURCE=$(HOME)/gtk/source
PREFIX = /usr/local

# Extra distribution file names
README_FILE = README.md
LICENSE_FILE = LICENSE
3RD_P_LIC_FILE = 3rd-party-licenses.txt
LICENSES_FILE = licenses

EXTRA_DIST = README.md ../LICENSE ../docs/3rd-party-licenses.txt ../docs/licenses

CONFIGURE_ARGS = --prefix="$(PREFIX)" --with-libdnet=included --with-libpcap=included --with-libpcre=included --with-liblua=included CC="$(CC)" CXX="$(CXX)" CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" PYTHON="$(PYTHON)"

CFLAGS = -mmacosx-version-min=$(OSX_MIN_VERSION)
CXXFLAGS = -mmacosx-version-min=$(OSX_MIN_VERSION)

# Jhbuild static libraries
PYTHON = $(JHBUILD_PREFIX)/bin/python3
OPENSSL_STATIC = $(JHBUILD_PREFIX)/lib/libssl.a $(JHBUILD_PREFIX)/lib/libcrypto.a
LIBZ_STATIC = $(JHBUILD_PREFIX)/lib/libz.a

# These are the positions used by the createdmg.sh and check_test.sh scripts
export ICON_SIZE=88
export FONT_SIZE=13
export MPKG_POS_X=110
export MPKG_POS_Y=170
export APPS_POS_X=110
export APPS_POS_Y=310
export README_POS_X=802
export README_POS_Y=180
export LICENSE_POS_X=802
export LICENSE_POS_Y=310
export THIRD_P_POS_X=802
export THIRD_P_POS_Y=440
export LICENSES_POS_X=670
export LICENSES_POS_Y=60

$(IMAGE_NAME): tool-checks $(IMAGE_STAGING_DIR)/$(PKG_NAME)
	rm -f $@
	# Create the dmg disk image and convert it to read only disk
	./createdmg.sh $(IMAGE_STAGING_DIR) $(README_FILE) $(LICENSE_FILE) $(3RD_P_LIC_FILE) $(LICENSES_FILE)
	# Check the created disk image for the sizes, backgrounds and icons presence and positions
	./check_test.sh $(README_FILE) $(LICENSE_FILE) $(3RD_P_LIC_FILE) $(LICENSES_FILE)

tool-checks: have-jhbuild have-gtk-mac-bundler

have-%:
	which $*

#$(IMAGE_STAGING_DIR)/$(PKG_NAME): check-nmap check-ncat check-ndiff check-zenmap check-nping LICENSE.formatted
$(IMAGE_STAGING_DIR)/$(PKG_NAME): check-nmap check-ncat check-ndiff check-zenmap check-nping LICENSE.formatted
	rm -rf $(IMAGE_STAGING_DIR)
	mkdir -p $(IMAGE_STAGING_DIR)
	cp -rf $(EXTRA_DIST) $(IMAGE_STAGING_DIR)/
	# Create packages (.pkg) for all the components to install in the installer (.mpkg)
	pkgbuild --root $(NMAP_STAGING_DIR) --identifier org.insecure.nmap --version $(NMAP_VERSION) --install-location /usr/local nmap.pkg
	pkgbuild --root $(NCAT_STAGING_DIR) --identifier org.insecure.nmap.ncat --version $(NMAP_VERSION) --install-location /usr/local ncat.pkg
	pkgbuild --root $(NDIFF_STAGING_DIR)/usr/local --identifier org.insecure.nmap.ndiff --version $(NMAP_VERSION) --install-location /usr/local ndiff.pkg
	pkgbuild --root $(NPING_STAGING_DIR) --identifier org.insecure.nmap.nping --version $(NMAP_VERSION) --install-location /usr/local nping.pkg
	pkgbuild --root $(ZENMAP_STAGING_DIR) --identifier org.insecure.nmap.zenmap --version $(NMAP_VERSION) --install-location /Applications zenmap.pkg

	# Produce a .xml with packages information
	productbuild --synthesize \
		--package 'nmap.pkg' \
		--package 'ncat.pkg' \
		--package 'ndiff.pkg' \
		--package 'nping.pkg' \
		--package 'zenmap.pkg' \
		distribution.xml

	# Make a new file and add background and title attributes
	head -n 2 distribution.xml > finalDist.xml
	echo "    <title>Nmap $(NMAP_VERSION)</title>" >> finalDist.xml
	# This line is for adding a background image to the .mpkg
	echo "    <background file=\"pkg_bg.jpg\" mime-type=\"image/jpeg\" scaling=\"proportional\" alignment=\"bottomleft\"/>" >> finalDist.xml
	tail -n +3 distribution.xml >> finalDist.xml

	# Build the .mpkg according to the final .xml file (and so all the .pkg)
	productbuild --distribution finalDist.xml --resources . --package-path . $(NAME_VERSION).mpkg

	mv $(NAME_VERSION).mpkg $(NAME_VERSION)/$(NAME_VERSION).mpkg

check-%: stage-%
	(find $*-root -perm -a+x -type f | xargs otool -L | awk '/:$$/{e=$$0}index($$0,"$(JHBUILD_PREFIX)"){x=1;print e; print}END{exit x}') && echo "Libs are clean"

export-%:
	rm -rf $*
# Using @BASE discards local changes.
	svn export .. $*

export-tarball:
	rm -rf nmap-$(NMAP_VERSION)
	svn export .. nmap-$(NMAP_VERSION)
	tar czf nmap-$(NMAP_VERSION).tar.gz nmap-$(NMAP_VERSION)
	cp nmap-$(NMAP_VERSION).tar.gz $(JHBUILD_SOURCE)/pkgs/

xstage-nmap: export-$(NMAP_BUILD_DIR)
	cd $(NMAP_BUILD_DIR) && ./configure --without-zenmap --without-ncat --without-ndiff --without-nping --with-openssl="$(JHBUILD_PREFIX)" --with-libz="$(JHBUILD_PREFIX)" $(CONFIGURE_ARGS)
	# LIB* is libssh2's name for *_LIBS
	make -C $(NMAP_BUILD_DIR) OPENSSL_LIBS="$(OPENSSL_STATIC)" LIBSSL="$(OPENSSL_STATIC)" ZLIB_LIBS="$(LIBZ_STATIC)" LIBZ="$(LIBZ_STATIC)"
	rm -rf $(NMAP_STAGING_DIR)
	make -C $(NMAP_BUILD_DIR) install DESTDIR="`pwd`/$(NMAP_STAGING_DIR)" OPENSSL_LIBS="$(OPENSSL_STATIC)" ZLIB_LIBS="$(LIBZ_STATIC)"

xstage-ncat: export-$(NCAT_BUILD_DIR)
	cd $(NCAT_BUILD_DIR) && ./configure --without-zenmap --with-ncat --without-ndiff --without-nping --with-openssl="$(JHBUILD_PREFIX)" $(CONFIGURE_ARGS)
	make -C $(NCAT_BUILD_DIR) build-ncat OPENSSL_LIBS="$(OPENSSL_STATIC)"
	rm -rf $(NCAT_STAGING_DIR)
	make -C $(NCAT_BUILD_DIR) install-ncat DESTDIR="`pwd`/$(NCAT_STAGING_DIR)" OPENSSL_LIBS="$(OPENSSL_STATIC)"

xstage-nping: export-$(NPING_BUILD_DIR)
	cd $(NPING_BUILD_DIR) && ./configure --without-zenmap --without-ncat --without-ndiff --with-nping --with-openssl="$(JHBUILD_PREFIX)" $(CONFIGURE_ARGS)
	make -C $(NPING_BUILD_DIR) build-nping OPENSSL_LIBS="$(OPENSSL_STATIC)"
	rm -rf $(NPING_STAGING_DIR)
	make -C $(NPING_BUILD_DIR) install-nping DESTDIR="`pwd`/$(NPING_STAGING_DIR)" OPENSSL_LIBS="$(OPENSSL_STATIC)"

openssl.modules: ../nmap.h
	sed -i.bak '/ENTITY nmap_version/s/\".*\"/\"$(NMAP_VERSION)\"/' $@

stage-%: export-tarball openssl.modules
	jhbuild -m "file://`pwd`/openssl.modules" build $*
	rm -rf $*-root
	mkdir $*-root
	rsync -a --files-from "$(JHBUILD_PREFIX)/_jhbuild/manifests/$*" "$(JHBUILD_PREFIX)" $*-root/

stage-zenmap: export-$(ZENMAP_BUILD_DIR)
	cd $(ZENMAP_BUILD_DIR)/zenmap && jhbuild run install_scripts/macosx/make-bundle.sh
	rm -rf $(ZENMAP_STAGING_DIR)
	mkdir -p $(ZENMAP_STAGING_DIR)
	cp -rf $(ZENMAP_BUILD_DIR)/zenmap/dist/Zenmap.app $(ZENMAP_STAGING_DIR)

stage-ndiff: export-$(NDIFF_BUILD_DIR)
	mkdir -p $(NDIFF_STAGING_DIR)/usr/local/bin
	mkdir -p $(NDIFF_STAGING_DIR)/usr/local/share/man/man1
	cp $(NDIFF_BUILD_DIR)/ndiff/ndiff.py $(NDIFF_STAGING_DIR)/usr/local/bin/ndiff
	cp $(NDIFF_BUILD_DIR)/ndiff/docs/ndiff.1 $(NDIFF_STAGING_DIR)/usr/local/share/man/man1/

LICENSE.formatted:
# Use the license formatter from the Windows installer.
	../mswin32/license-format/licformat.sh ../LICENSE > $@

clean:
	rm -rf $(IMAGE_STAGING_DIR)
	rm -rf $(NMAP_BUILD_DIR)
	rm -rf $(NMAP_STAGING_DIR)
	rm -rf $(ZENMAP_BUILD_DIR)
	rm -rf $(ZENMAP_STAGING_DIR)
	rm -rf $(NCAT_BUILD_DIR)
	rm -rf $(NCAT_STAGING_DIR)
	rm -rf $(NDIFF_BUILD_DIR)
	rm -rf $(NDIFF_STAGING_DIR)
	rm -rf $(NPING_BUILD_DIR)
	rm -rf $(NPING_STAGING_DIR)
	rm -f LICENSE.formatted
	rm -f $(IMAGE_NAME)
	rm -rf distribution.xml finalDist.xml nmap.pkg ncat.pkg ndiff.pkg nping.pkg zenmap.pkg

.PHONY: clean export-% stage-%

=== debian/changelog ===
nmap (7.95+dfsg-3kali1) kali-dev; urgency=medium

  * Sync with Debian
  * Refresh patches
  * Remove embedded libpcap in Kali

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 15 May 2025 17:37:26 +0200

nmap (7.95+dfsg-1kali1) kali-dev; urgency=medium

  * Sync with Debian

 -- Steev Klimaszewski <steev@kali.org>  Fri, 03 Jan 2025 14:56:18 -0600

nmap (7.94+git20230807.3be01efb1+dfsg-4kali4) kali-dev; urgency=medium

  * Don't pass privileged flag if resuming

 -- Steev Klimaszewski <steev@kali.org>  Thu, 19 Dec 2024 13:20:35 -0600

nmap (7.94+git20230807.3be01efb1+dfsg-4kali3) kali-dev; urgency=medium

  * Ensure directories are available before writing to them.

 -- Steev Klimaszewski <steev@kali.org>  Mon, 28 Oct 2024 22:17:29 -0500

nmap (7.94+git20230807.3be01efb1+dfsg-4kali2) kali-dev; urgency=medium

  * Add capabilities, take 2.

 -- Steev Klimaszewski <steev@kali.org>  Mon, 23 Sep 2024 18:09:00 -0500

nmap (7.94+git20230807.3be01efb1+dfsg-4kali1) kali-dev; urgency=medium

  * Sync with Debian

 -- Steev Klimaszewski <steev@kali.org>  Thu, 19 Sep 2024 15:52:47 -0500

nmap (7.94+git20230807.3be01efb1+dfsg-2+kali3) kali-dev; urgency=medium

  * d/upstream: Add upstream metadata
  * Revert "Fix prerm to remove the correct file"
  * Revert "Add capabilities to nmap"

 -- Steev Klimaszewski <steev@kali.org>  Thu, 20 Jun 2024 13:27:53 -0500

nmap (7.94+git20230807.3be01efb1+dfsg-2+kali2) kali-experimental; urgency=medium

  * Add capabilities to nmap
  * Fix prerm to remove the correct file

 -- Steev Klimaszewski <steev@kali.org>  Wed, 13 Mar 2024 14:13:17 -0500

nmap (7.94+git20230807.3be01efb1+dfsg-2+kali1) kali-dev; urgency=medium

  * Sync with Debian

 -- Arnaud Rebillout <arnaudr@kali.org>  Thu, 02 Nov 2023 09:10:47 +0700

nmap (7.94+dfsg1-1kali2) kali-dev; urgency=medium

  * Strip unknown ARM64 CFLAG from the build.

 -- Steev Klimaszewski <steev@kali.org>  Mon, 18 Sep 2023 14:18:53 -0500

nmap (7.94+dfsg1-1kali1) kali-dev; urgency=medium

  * Sync with Debian
  * Refresh patches
  * Update lintian-overrides

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 01 Jun 2023 15:02:29 +0200

nmap (7.93+dfsg1-0kali3) kali-experimental; urgency=medium

  * Fix issues in ms-sql* scripts

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 28 Mar 2023 11:20:29 +0200

nmap (7.93+dfsg1-0kali2) kali-dev; urgency=medium

  * Set ncat's alternatives priority to zero

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 10 Jan 2023 11:24:30 +0700

nmap (7.93+dfsg1-0kali1) kali-dev; urgency=medium

  * New upstream version 7.93+dfsg1
  * Update copyright and move the package to non-free
  * Refresh patches
  * Update lintian-overrides
  * Update debian/copyright
  * Bump Standards-Version to 4.6.1 (no changes)

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 06 Oct 2022 16:43:41 +0200

nmap (7.92+dfsg2-1kali1) kali-dev; urgency=medium

  * Sync with Debian: Keep libpcap embedded for Kali
  * Refresh patches (remove obsolete patch to fix the build)

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 18 Jan 2022 15:54:46 +0100

nmap (7.92+dfsg1-0kali1) kali-dev; urgency=medium

  [ Arnaud Rebillout ]
  * Configure gbp import-dsc for a Debian-derived package

  [ Kali Janitor ]
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Sophie Brun ]
  * New upstream version 7.92+dfsg1
  * Refresh patches
  * Add a patch to fix build
  * Update debian/copyright

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 26 Oct 2021 09:29:00 +0200

nmap (7.91+dfsg1-1kali1) kali-dev; urgency=medium

  * Import new upstream release. Keep libpcap embedded for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 12 Oct 2020 15:29:14 +0200

nmap (7.80+dfsg1-5kali1) kali-dev; urgency=medium

  * Import new upstream release. Keep libpcap embedded for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 13 Jul 2020 11:03:54 +0200

nmap (7.80+dfsg1-2kali2) kali-dev; urgency=medium

  * Refresh patch and import upstream patch to fix issue

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 10 Mar 2020 17:52:31 +0100

nmap (7.80+dfsg1-2kali1) kali-dev; urgency=medium

  * Import new upstream release. Keep libpcap embedded for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 26 Nov 2019 10:21:49 +0100

nmap (7.80+dfsg1-1kali1) kali-dev; urgency=medium

  * Import new upstream release. Keep libpcap embedded for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 16 Aug 2019 13:47:35 +0200

nmap (7.70+dfsg1-6kali1) kali-dev; urgency=medium

  * Import new upstream release. Keep libpcap embedded for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 09 Jan 2019 16:01:01 +0100

nmap (7.70+dfsg1-5kali1) kali-dev; urgency=medium

  * Import new upstream release. Keep libpcap embedded for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 12 Nov 2018 15:10:19 +0100

nmap (7.70+dfsg1-3kali1) kali-dev; urgency=medium

  * Import new upstream release. Keep libpcap embedded for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 15 May 2018 11:31:30 +0200

nmap (7.70+dfsg1-0kali2) kali-dev; urgency=medium

  * Rebuild with Debian orig.tag.xz

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 02 Apr 2018 21:12:38 +0200

nmap (7.70+dfsg1-0kali1) kali-dev; urgency=medium

  * Import new upstream release. Keep libpcap embedded for Kali
  * Remove merged patches: 0004-library-versions.patch 0005-autotools.patch
    0006-move-manual-defines.patch
  * Update debian/copyright

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 26 Mar 2018 14:18:16 +0200

nmap (7.60+dfsg2-1kali1) kali-dev; urgency=medium

  * Synchronize with Debian: reintroduce libpcap included for Kali
    (see bug 4226)

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 09 Nov 2017 13:34:04 +0100

nmap (7.40-1kali1) kali-dev; urgency=medium

  * Synchronize with Debian: keep libpcap included for Kali



=== debian/control ===
Source: nmap
Section: non-free/net
Priority: optional
XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Hilko Bengen <bengen@debian.org>,
           Samuel Henrique <samueloph@debian.org>
Build-Depends: bison,
               debhelper-compat (= 13),
               dh-python,
               flex,
               liblinear-dev,
               liblua5.4-dev,
               libpcap0.8-dev,
               libpcre2-dev,
               libssh2-1-dev,
               libssl-dev,
               lua-lpeg-dev,
               gir1.2-gtk-3.0,
               gir1.2-pango-1.0,
               gir1.2-glib-2.0,
               gir1.2-gdkpixbuf-2.0,
Build-Depends-Indep: default-jdk-headless,
                     dh-sequence-python3,
                     gcc-mingw-w64-i686,
                     python3,
                     python3-pip,
                     python3-gi,
                     python3-setuptools,
                     pybuild-plugin-pyproject,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://nmap.org/
XS-Debian-Vcs-Git: https://salsa.debian.org/pkg-security-team/nmap.git
XS-Debian-Vcs-Browser: https://salsa.debian.org/pkg-security-team/nmap
Vcs-Git: https://gitlab.com/kalilinux/packages/nmap.git
Vcs-Browser: https://gitlab.com/kalilinux/packages/nmap

Package: nmap
Architecture: any
Depends: nmap-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: ncat, ndiff, zenmap
Description: The Network Mapper
 Nmap is a utility for network exploration or security auditing. It
 supports ping scanning (determine which hosts are up), many port
 scanning techniques, version detection (determine service protocols
 and application versions listening behind ports), and TCP/IP
 fingerprinting (remote host OS or device identification). Nmap also
 offers flexible target and port specification, decoy/stealth scanning,
 sunRPC scanning, and more. Most Unix and Windows platforms are
 supported in both GUI and commandline modes. Several popular handheld
 devices are also supported, including the Sharp Zaurus and the iPAQ.

Package: nmap-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: nmap
Description: Architecture independent files for nmap
 Nmap is a utility for network exploration or security auditing. It
 supports ping scanning (determine which hosts are up), many port
 scanning techniques, version detection (determine service protocols
 and application versions listening behind ports), and TCP/IP
 fingerprinting (remote host OS or device identification). Nmap also
 offers flexible target and port specification, decoy/stealth scanning,
 sunRPC scanning, and more. Most Unix and Windows platforms are
 supported in both GUI and commandline modes. Several popular handheld
 devices are also supported, including the Sharp Zaurus and the iPAQ.
 .
 This package contains the nmap files shared by all architectures.

Package: zenmap
Architecture: all
Depends: ndiff,
         nmap,
         python3-gi, 
         python3-gi-cairo,
         gir1.2-gtk-3.0,
         gir1.2-pango-1.0,
         gir1.2-glib-2.0,
         gir1.2-gdkpixbuf-2.0,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: pkexec
Description: The Network Mapper Front End
 Zenmap is an Nmap frontend. It is meant to be useful for advanced users
 and to make Nmap easy to use by beginners. It was originally derived
 from Umit, an Nmap GUI created as part of the Google Summer of Code.

Package: ndiff
Architecture: all
Recommends: nmap
Breaks: nmap (<< ${source:Version})
Depends: python3-lxml,
         ${misc:Depends},
         ${python3:Depends},
Description: The Network Mapper - result compare utility
 Ndiff is a tool to aid in the comparison of Nmap scans. It takes two
 Nmap XML output files and prints the differences between them them:
 hosts coming up and down, ports becoming open or closed, and things like that.
 It can produce output in human-readable text or machine-readable XML formats.

Package: ncat
Architecture: any
Depends: ${misc:Depends},  ${shlibs:Depends}
Description: NMAP netcat reimplementation
 ncat is a reimplementation of Netcat by the NMAP project, providing
 most of the features present in the original implementations, along
 with some new features such as IPv6 and SSL support. Port scanning
 support has been removed.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# mingw does not know about the arm64 specific cflag branch-protection
# so strip it out of the build, so that the build doesn't fail.
export DEB_CFLAGS_MAINT_STRIP = -mbranch-protection=standard

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	VENDOR_CONFIGURE_OPTIONS = --with-libssh2=included
endif

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --sourcedir=ndiff --buildsystem=pybuild -- --name=ndiff
	dh_auto_clean --sourcedir=zenmap --buildsystem=pybuild -- --name=zenmap

override_dh_auto_configure:
	dh_auto_configure -- \
		--with-liblua=/usr \
		--with-liblinear \
		--without-zenmap \
		--without-ndiff \
		--enable-ipv6 \
		STRIP=/bin/true

execute_after_dh_auto_configure-indep:
	dh_auto_configure --sourcedir=ndiff --buildsystem=pybuild -- --name=ndiff
	dh_auto_configure --sourcedir=zenmap --buildsystem=pybuild -- --name=zenmap

mingw_CFLAGS = $(filter-out -mbranch-protection=standard,$(CFLAGS))

execute_after_dh_auto_build-indep:
	dh_auto_build --sourcedir=ndiff --buildsystem=pybuild -- --name=ndiff
	dh_auto_build --sourcedir=zenmap --buildsystem=pybuild -- --name=zenmap

	cd nselib/data/jdwp-class && /usr/lib/jvm/default-java/bin/javac *.java
	cd nselib/data/psexec && \
		i686-w64-mingw32-gcc ${CPPFLAGS} ${mingw_CFLAGS} -o nmap_service.exe nmap_service.c && \
		gzip -c -n9 nmap_service.exe | base64 | tac > nmap_service.ex_

override_dh_auto_test-arch:

override_dh_auto_test-indep:
	dh_auto_test --sourcedir=ndiff --buildsystem=pybuild -- --name=ndiff
	dh_auto_test --sourcedir=zenmap --buildsystem=pybuild -- --name=zenmap

execute_after_dh_auto_install-arch:
	mv debian/tmp/usr/share/man/pt_PT debian/tmp/usr/share/man/pt

execute_after_dh_auto_install-indep:
	dh_auto_install --sourcedir=ndiff --buildsystem=pybuild --destdir=debian/ndiff -- --name=ndiff
	dh_auto_install --sourcedir=zenmap --buildsystem=pybuild --destdir=debian/zenmap -- --name=zenmap

## nmap 7.98%2Bdfsg

=== debian/changelog ===
nmap (7.98+dfsg-1) unstable; urgency=medium

  * New upstream version 7.98+dfsg (closes: #1115950)
  * d/patches:
    - gbp pq import/export patches (refresh)
    - Disable-custom-functions-in-ndiff-setup.py.patch: Drop patch, not needed
      anymore
    - dont_define_strlcat_in_libdnet.patch: New patch, drop strlcat definition
      from embedded library libdnet-stripped

 -- Samuel Henrique <samueloph@debian.org>  Wed, 29 Oct 2025 20:21:08 +0000

## nmap 7.98+dfsg

=== libdnet-stripped/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(dnet VERSION 1.18.0 LANGUAGES C)

find_package(TCL)

include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckStructHasMember)
include(CheckSymbolExists)
include(CheckTypeSize)
include(CheckCSourceCompiles)
include(GNUInstallDirs)
include(CMakePushCheckState)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS True)
option(BUILD_SHARED_LIBS "Build in shared lib mode" OFF)

set(DNET_LINK_LIBS "")

foreach (header stdio.h stdlib.h string.h inttypes.h)
  string(TOUPPER HAVE_${header} var)
  string(REGEX REPLACE "\\.|/" "_" var ${var})
  check_include_file(${header} ${var})
endforeach ()

if(WIN32)
    find_package(Packet)
    if(Packet_FOUND)
        set(HAVE_PACKET32 TRUE)
        set(HAVE_PCAP_H TRUE)
        include_directories(${Packet_INCLUDE_DIRS})
        set(DNET_LINK_LIBS ${Packet_LIBRARIES} ${DNET_LINK_LIBS})
    endif(Packet_FOUND)
endif(WIN32)

if (MSVC)
    add_definitions(-DWIN32_LEAN_AND_MEAN)
    check_include_file(winsock2.h HAVE_WINSOCK2_H)
    if(HAVE_WINSOCK2_H)
        set(HAVE_SOCKADDR_IN6 TRUE)
        set(HAVE_LIBWS2_32 TRUE)
        set(DNET_LINK_LIBS ws2_32 ${DNET_LINK_LIBS})
    endif()
    check_c_source_compiles("
        #define WIN32_LEAN_AND_MEAN
        #include <windows.h>
        #include <Iphlpapi.h>
        int main() { return 0; }"
        HAVE_IPHLPAPI_H)
    if(HAVE_IPHLPAPI_H)
        set(HAVE_LIBIPHLPAPI TRUE)
        set(DNET_LINK_LIBS Iphlpapi ${DNET_LINK_LIBS})
    endif()
    cmake_push_check_state()
    set(CMAKE_REQUIRED_LIBRARIES "ws2_32")
    check_symbol_exists(inet_pton WS2tcpip.h HAVE_INET_PTON)
    cmake_pop_check_state()
endif()
if(UNIX)
    foreach (header strings.h
            unistd.h sys/bufmod.h sys/dlpi.h sys/dlpihdr.h sys/dlpi_ext.h
            sys/ioctl.h sys/mib.h sys/ndd_var.h sys/socket.h sys/sockio.h
            sys/time.h sys/stat.h net/if.h net/if_var.h
            net/if_dl.h net/pfilt.h
            net/radix.h net/raw.h net/route.h netinet/in_var.h
            linux/if_tun.h netinet/ip_fw.h linux/ip_fw.h
            linux/ip_fwchains.h linux/netfilter_ipv4/ipchains_core.h
            ip_fil_compat.h netinet/ip_fil_compat.h ip_compat.h
            netinet/ip_compat.h ip_fil.h netinet/ip_fil.h
            hpsecurity.h stropts.h dlfcn.h fcntl.h)
      string(TOUPPER HAVE_${header} var)
      string(REGEX REPLACE "\\.|/" "_" var ${var})
      check_include_file(${header} ${var})
    endforeach ()

    check_include_files("sys/types.h;net/bpf.h" HAVE_NET_BPF_H)
    check_include_files("sys/types.h;net/if_arp.h" HAVE_NET_IF_ARP_H)
    check_include_files("sys/types.h;net/if_tun.h" HAVE_NET_IF_TUN_H)
    check_include_files("sys/types.h;net/if.h;net/pfvar.h" HAVE_NET_PFVAR_H)
    check_include_files("sys/types.h;sys/sysctl.h" HAVE_SYS_SYSCTL_H)
endif()

set(CMAKE_REQUIRED_LIBRARIES )
foreach (func err strlcat strlcpy strse)
  string(TOUPPER HAVE_${func} var)
  check_function_exists(${func} ${var})
endforeach ()

if (UNIX)
    set(CMAKE_REQUIRED_LIBRARIES "nm")
    check_function_exists(open_mib HAVE_OPEN_MIB)
    set(CMAKE_REQUIRED_LIBRARIES )

    CHECK_STRUCT_HAS_MEMBER("struct arpreq" arp_dev net/if_arp.h HAVE_ARPREQ_ARP_DEV LANGUAGE C)
    CHECK_STRUCT_HAS_MEMBER("struct sockaddr" sa_len sys/socket.h HAVE_SOCKADDR_SA_LEN LANGUAGE C)
    CHECK_STRUCT_HAS_MEMBER("struct rt_msghdr" rtm_msglen "sys/socket.h;net/if.h;net/route.h" HAVE_ROUTE_RT_MSGHDR LANGUAGE C)

    set(CMAKE_EXTRA_INCLUDE_FILES "netinet/in.h")
    check_type_size("struct sockaddr_in6" HAVE_SOCKADDR_IN6  LANGUAGE C)
    set(CMAKE_EXTRA_INCLUDE_FILES )

    if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
        file(STRINGS /proc/sys/kernel/ostype PROCFS)
        message(STATUS "${PROCFS}")
        if (${PROCFS} STREQUAL "Linux")
            set(HAVE_LINUX_PROCFS True)
        endif()
    endif()

    check_include_file(inet/mib2.h HAVE_STREAMS_MIB2)

    check_symbol_exists(ETH_P_ALL linux/if_ether.h HAVE_LINUX_PF_PACKET)

    check_symbol_exists(RTSTR_SEND net/route.h HAVE_STREAMS_ROUTE)

    check_symbol_exists(SIOCGARP sys/ioctl.h HAVE_IOCTL_ARP)

    string(TOLOWER ${CMAKE_SYSTEM_NAME} CMAKE_SYSTEM_NAME_LOWER)

    string(REGEX MATCH "bsd" BSD ${CMAKE_SYSTEM_NAME_LOWER})
    string(REGEX MATCH "darwin" DARWIN ${CMAKE_SYSTEM_NAME_LOWER})
    string(REGEX MATCH "osf" OSF ${CMAKE_SYSTEM_NAME_LOWER})
    string(REGEX MATCH "unixware" UNIXWARE ${CMAKE_SYSTEM_NAME_LOWER})
    string(REGEX MATCH "openbsd" OPENBSD ${CMAKE_SYSTEM_NAME_LOWER})
    string(REGEX MATCH "solaris" SOLARIS ${CMAKE_SYSTEM_NAME_LOWER})
    string(REGEX MATCH "irix" IRIX ${CMAKE_SYSTEM_NAME_LOWER})
    string(REGEX MATCH "freebsd5" FREEBSD5 ${CMAKE_SYSTEM_NAME_LOWER})
    string(REGEX MATCH "kfreebsd" KFREEBSD ${CMAKE_SYSTEM_NAME_LOWER})

    if (BSD OR DARWIN OR OSF OR UNIXWARE)
        set(HAVE_RAWIP_HOST_OFFLEN True)
    endif()

    if (OPENBSD)
        set(HAVE_RAWIP_HOST_OFFLEN False)
    endif()

    if (SOLARIS OR IRIX)
        set(HAVE_RAWIP_COOKED True)
    endif()

    set(CMAKE_REQUIRED_LIBRARIES )
    foreach (func err strlcat strlcpy strse)
      string(TOUPPER HAVE_${func} var)
      check_function_exists(${func} ${var})
    endforeach ()



    set(CMAKE_REQUIRED_LIBRARIES nsl socket)
    check_function_exists(gethostbyname HAVE_GETHOSTBYNAME)
    if (NOT HAVE_GETHOSTBYNAME)
        unset(HAVE_GETHOSTBYNAME CACHE)
        set(CMAKE_REQUIRED_LIBRARIES nsl)
        check_function_exists(gethostbyname HAVE_GETHOSTBYNAME)
        if (NOT HAVE_GETHOSTBYNAME)
            unset(HAVE_GETHOSTBYNAME CACHE)
            set(CMAKE_REQUIRED_LIBRARIES)
            check_function_exists(gethostbyname HAVE_GETHOSTBYNAME)
        endif()
    endif()
    set(CMAKE_REQUIRED_LIBRARIES )
    check_function_exists(gethostbyaddr HAVE_GETHOSTBYADDR)
    check_function_exists(gethostname HAVE_GETHOSTNAME)
endif (UNIX)

check_function_exists(inet_ntoa HAVE_INET_NTOA)
check_function_exists(memset HAVE_MEMSET)
check_function_exists(select HAVE_SELECT)
check_function_exists(socket HAVE_SOCKET)
check_function_exists(strerror HAVE_STRERROR)
check_function_exists(strsep HAVE_STRSEP)

set(CMAKE_REQUIRED_LIBRARIES str)
check_function_exists(putmsg HAVE_PUTMSG)
set(CMAKE_REQUIRED_LIBRARIES )

set(PACKAGE ${PROJECT_NAME})
set(PACKAGE_BUGREPORT)
set(PACKAGE_NAME ${PROJECT_NAME})
set(PACKAGE_STRING "${PROJECT_NAME} ${CMAKE_PROJECT_VERSION}")
set(PACKAGE_TARNAME ${PROJECT_NAME})
set(PACKAGE_URL)
set(PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(VERSION ${CMAKE_PROJECT_VERSION})

configure_file(config.h.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

set(PLATFORM_SOURCES)

if (NOT HAVE_STRLCAT)
    list(APPEND PLATFORM_SOURCES src/strlcat.c)
endif()
if (NOT HAVE_STRLCPY)
    list(APPEND PLATFORM_SOURCES src/strlcpy.c)
endif()
if (NOT HAVE_STRSEP)
    list(APPEND PLATFORM_SOURCES src/strsep.c)
endif()


if (HAVE_ROUTE_RT_MSGHDR)
    list(APPEND PLATFORM_SOURCES src/arp-bsd.c)
elseif (HAVE_IOCTL_ARP)
    list(APPEND PLATFORM_SOURCES src/arp-ioctl.c)
elseif (HAVE_IPHLPAPI_H)
    list(APPEND PLATFORM_SOURCES src/arp-win32.c)
else()
    list(APPEND PLATFORM_SOURCES src/arp-none.c)
endif()

if (HAVE_PACKET32)
    list(APPEND PLATFORM_SOURCES src/eth-win32.c)
elseif(HAVE_NET_PFILT_H)
    list(APPEND PLATFORM_SOURCES src/eth-pfilt.c)
elseif(HAVE_LINUX_PF_PACKET)
    list(APPEND PLATFORM_SOURCES src/eth-linux.c)
elseif(HAVE_NET_BPF_H)
    list(APPEND PLATFORM_SOURCES src/eth-bsd.c)
elseif(HAVE_NET_RAW_H)
    list(APPEND PLATFORM_SOURCES src/eth-snoop.c)
elseif(HAVE_SYS_NDD_VAR_H)
    list(APPEND PLATFORM_SOURCES src/eth-ndd.c)
elseif(HAVE_SYS_DLPI_H OR HAVE_SYS_DLPIHDR_H)
    list(APPEND PLATFORM_SOURCES src/eth-dlpi.c)
else()
    list(APPEND PLATFORM_SOURCES src/eth-none.c)
endif()

if (HAVE_IPHLPAPI_H)
    list(APPEND PLATFORM_SOURCES src/fw-pktfilter.c)
elseif(HAVE_NET_PFVAR_H)
    list(APPEND PLATFORM_SOURCES src/fw-pf.c)
elseif(HAVE_NETINET_IP_FW_H)
    if (FREEBSD5 OR KFREEBSD)
        list(APPEND PLATFORM_SOURCES src/fw-none.c)
    else()
        list(APPEND PLATFORM_SOURCES src/fw-ipfw.c)
    endif()
elseif(HAVE_IP_FIL_H)
    list(APPEND PLATFORM_SOURCES src/fw-ipf.c)
elseif(HAVE_LINUX_IP_FW_H OR HAVE_LINUX_IP_FWCHAINS_H OR HAVE_LINUX_NETFILTER_IPV4_IPCHAINS_CORE_H)
    list(APPEND PLATFORM_SOURCES src/fw-ipchains.c)
else()
    list(APPEND PLATFORM_SOURCES src/fw-none.c)
endif()

if (HAVE_IPHLPAPI_H)
    list(APPEND PLATFORM_SOURCES src/intf-win32.c)
else()
    list(APPEND PLATFORM_SOURCES src/intf.c)
endif()

if (HAVE_IPHLPAPI_H)
    list(APPEND PLATFORM_SOURCES src/ip-win32.c)
elseif(HAVE_RAWIP_COOKED)
    list(APPEND PLATFORM_SOURCES src/ip-cooked.c)
else()
    list(APPEND PLATFORM_SOURCES src/ip.c)
endif()

if (HAVE_IPHLPAPI_H)
    list(APPEND PLATFORM_SOURCES src/route-win32.c)
elseif(HAVE_ROUTE_RT_MSGHDR)
    list(APPEND PLATFORM_SOURCES src/route-bsd.c)
elseif(HAVE_LINUX_PROCFS)
    list(APPEND PLATFORM_SOURCES src/route-linux.c)
elseif(HAVE_HPSECURITY_H)
    list(APPEND PLATFORM_SOURCES src/route-hpux.c)
else()
    list(APPEND PLATFORM_SOURCES src/route-none.c)
endif()

if(HAVE_LINUX_PROCFS)
    list(APPEND PLATFORM_SOURCES src/ndisc-linux.c)
else()
    list(APPEND PLATFORM_SOURCES src/ndisc-none.c)
endif()

find_file(HAVE_DEV_TUN
            NAMES /dev/tun0
            DOC "Check for tun0")

if(HAVE_LINUX_IF_TUN_H)
    list(APPEND PLATFORM_SOURCES src/tun-linux.c)
elseif(HAVE_NET_IF_TUN_H)
    if(HAVE_STROPTS_H)
        list(APPEND PLATFORM_SOURCES src/tun-solaris.c)
    else()
        list(APPEND PLATFORM_SOURCES src/tun-bsd.c)
    endif()
elseif(HAVE_DEV_TUN)
    list(APPEND PLATFORM_SOURCES src/tun-bsd.c)
else()
    list(APPEND PLATFORM_SOURCES src/tun-none.c)
endif()

add_library(${PROJECT_NAME}
    src/addr-util.c
    src/addr.c
    src/blob.c
    src/err.c
    src/ip-util.c
    src/ip6.c
    src/rand.c
    ${PLATFORM_SOURCES})

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:include>
    $<INSTALL_INTERFACE:include/dnet>
)

set(DNET_HEADERS
    include/dnet/addr.h
    include/dnet/arp.h
    include/dnet/blob.h
    include/dnet/eth.h
    include/dnet/fw.h
    include/dnet/icmp.h
    include/dnet/icmpv6.h
    include/dnet/intf.h
    include/dnet/ip.h
    include/dnet/ip6.h
    include/dnet/ndisc.h
    include/dnet/os.h
    include/dnet/rand.h
    include/dnet/route.h
    include/dnet/sctp.h
    include/dnet/tcp.h
    include/dnet/tun.h
    include/dnet/udp.h
)
set(DNET_HEADERS1
    include/dnet.h
    include/err.h
    include/queue.h
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
)
set_target_properties(
    ${PROJECT_NAME}
    PROPERTIES
    PUBLIC_HEADER "${DNET_HEADERS}"
)

if(NOT(DNET_LINK_LIBS STREQUAL ""))
    target_link_libraries(${PROJECT_NAME} PUBLIC ${DNET_LINK_LIBS})
endif()

install(TARGETS ${PROJECT_NAME}
    EXPORT ${PROJECT_NAME}Targets DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT devel
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/${PROJECT_NAME} COMPONENT devel
)


install(FILES ${DNET_HEADERS1}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}
        COMPONENT devel)

install(EXPORT ${PROJECT_NAME}Targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}/
    FILE ${PROJECT_NAME}Targets.cmake
    NAMESPACE ${PROJECT_NAME}::
    COMPONENT devel
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/${PROJECT_NAME}-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
    @ONLY
)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/${PROJECT_NAME}-config-version.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
    @ONLY
)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake

=== macosx/Makefile ===
# This makefile builds a disk image (.dmg) containing the installer for Nmap,
# Zenmap, Ncat, and Ndiff.

export NMAP_VERSION := $(shell echo NMAP_VERSION | $(CPP) -imacros ../nmap.h - | sed -n '$$s/[" ]//g;$$p')
OSX_VERSION=$(shell sw_vers -productVersion | cut -d'.' -f1,2 | tr -d ' ')
export OSX_MIN_VERSION = 10.15

NAME_VERSION = nmap-$(NMAP_VERSION)$(if $(APPENDAGE),-$(APPENDAGE))

IMAGE_NAME = $(NAME_VERSION).dmg
PKG_NAME = $(NAME_VERSION).mpkg

IMAGE_STAGING_DIR = $(NAME_VERSION)

JHBUILD_PREFIX=$(HOME)/gtk/inst
JHBUILD_SOURCE=$(HOME)/gtk/source

# Extra distribution file names
README_FILE = README.md
LICENSE_FILE = LICENSE
3RD_P_LIC_FILE = 3rd-party-licenses.txt
LICENSES_FILE = licenses

EXTRA_DIST = README.md ../LICENSE ../docs/3rd-party-licenses.txt ../docs/licenses

CFLAGS = -mmacosx-version-min=$(OSX_MIN_VERSION)
CXXFLAGS = -mmacosx-version-min=$(OSX_MIN_VERSION)

# These are the positions used by the createdmg.sh and check_test.sh scripts
export ICON_SIZE=88
export FONT_SIZE=13
export MPKG_POS_X=110
export MPKG_POS_Y=170
export APPS_POS_X=110
export APPS_POS_Y=310
export README_POS_X=802
export README_POS_Y=180
export LICENSE_POS_X=802
export LICENSE_POS_Y=310
export THIRD_P_POS_X=802
export THIRD_P_POS_Y=440
export LICENSES_POS_X=670
export LICENSES_POS_Y=60

$(IMAGE_NAME): tool-checks $(IMAGE_STAGING_DIR)/$(PKG_NAME)
	rm -f $@
	# Create the dmg disk image and convert it to read only disk
	./createdmg.sh $(IMAGE_STAGING_DIR) $(README_FILE) $(LICENSE_FILE) $(3RD_P_LIC_FILE) $(LICENSES_FILE)
	# Check the created disk image for the sizes, backgrounds and icons presence and positions
	./check_test.sh $(README_FILE) $(LICENSE_FILE) $(3RD_P_LIC_FILE) $(LICENSES_FILE)

tool-checks: have-jhbuild have-gtk-mac-bundler

have-%:
	which $*

# Create packages (.pkg) for all the components to install in the installer (.mpkg)
PKGBUILD=pkgbuild --version $(NMAP_VERSION) --scripts Scripts --install-location /Applications --min-os-version $(OSX_MIN_VERSION)
%.pkg: check-%
	$(PKGBUILD) --root $*-root --identifier org.insecure.nmap.$* $@
nmap.pkg: check-nmap
	$(PKGBUILD) --root nmap-root --identifier org.insecure.nmap $@
zenmap.pkg: check-zenmap
	$(PKGBUILD) --root zenmap-root --identifier org.insecure.nmap.zenmap $@

#$(IMAGE_STAGING_DIR)/$(PKG_NAME): nmap.pkg ncat.pkg ndiff.pkg zenmap.pkg nping.pkg LICENSE.formatted
$(IMAGE_STAGING_DIR)/$(PKG_NAME): nmap.pkg ncat.pkg zenmap.pkg nping.pkg LICENSE.formatted
	rm -rf $(IMAGE_STAGING_DIR)
	mkdir -p $(IMAGE_STAGING_DIR)
	cp -rf $(EXTRA_DIST) $(IMAGE_STAGING_DIR)/

	# Produce a .xml with packages information
	productbuild --synthesize \
		--package 'nmap.pkg' \
		--package 'ncat.pkg' \
		--package 'nping.pkg' \
		--package 'zenmap.pkg' \
		distribution.xml

	# Make a new file and add background and title attributes
	head -n 2 distribution.xml > finalDist.xml
	echo "    <title>Nmap $(NMAP_VERSION)</title>" >> finalDist.xml
	# This line is for adding a background image to the .mpkg
	echo "    <background file=\"pkg_bg.jpg\" mime-type=\"image/jpeg\" scaling=\"proportional\" alignment=\"bottomleft\"/>" >> finalDist.xml
	tail -n +3 distribution.xml >> finalDist.xml

	# Build the .mpkg according to the final .xml file (and so all the .pkg)
	productbuild --distribution finalDist.xml --resources . --package-path . $(NAME_VERSION).mpkg

	mv $(NAME_VERSION).mpkg $(NAME_VERSION)/$(NAME_VERSION).mpkg

check-%: stage-%
	(find $*-root -perm -a+x -type f | xargs otool -L | awk '/:$$/{e=$$0}index($$0,"$(JHBUILD_PREFIX)"){x=1;print e; print}END{exit x}') && echo "Libs are clean"
	(find $*-root -perm -a+x -type f -exec otool -l {} \; | awk '/:$$/{e=$$0}$$1=="minos"&&$$2!="$(OSX_MIN_VERSION)"{x=1;print e; print}END{exit x}' ) && echo "Bins are clean"

check-zenmap: stage-zenmap
	(find zenmap-build -perm -a+x -type f | xargs otool -L | awk '/:$$/{e=$$0}index($$0,"$(JHBUILD_PREFIX)"){x=1;print e; print}END{exit x}') && echo "Libs are clean"
	(find zenmap-build -perm -a+x -type f -exec otool -l {} \; | awk '/:$$/{e=$$0}$$1=="minos"&&$$2!="$(OSX_MIN_VERSION)"{x=1;print e; print}END{exit x}' ) && echo "Bins are clean"

export-%:
	rm -rf $*
# Using @BASE discards local changes.
	svn export .. $*

NMAP_TARBALL=$(JHBUILD_SOURCE)/pkgs/nmap-$(NMAP_VERSION).tar.gz
$(NMAP_TARBALL):
	rm -rf nmap-$(NMAP_VERSION)
	svn export .. nmap-$(NMAP_VERSION)
	tar czf nmap-$(NMAP_VERSION).tar.gz nmap-$(NMAP_VERSION)
	cp nmap-$(NMAP_VERSION).tar.gz $(JHBUILD_SOURCE)/pkgs/

openssl.modules: ../nmap.h
	sed -i.bak '/ENTITY nmap_version/s/\".*\"/\"$(NMAP_VERSION)\"/' $@

clean-%: openssl.modules
	jhbuild -m "file://`pwd`/openssl.modules" uninstall $*

build-%: $(NMAP_TARBALL) openssl.modules
	jhbuild -m "file://`pwd`/openssl.modules" build $*

stage-%: build-%
	sh make-app.sh $* "$(JHBUILD_PREFIX)"

stage-zenmap: export-zenmap-build
	jhbuild run zenmap-build/zenmap/install_scripts/macosx/make-bundle.sh

build-ndiff:
	echo Nothing to do

LICENSE.formatted:
# Use the license formatter from the Windows installer.
	../mswin32/license-format/licformat.sh ../LICENSE > $@

clean: clean-nmap clean-ncat clean-nping
	rm -rf $(IMAGE_STAGING_DIR)
	rm -rf *-build/
	rm -rf *-root/
	rm -f LICENSE.formatted
	rm -f $(IMAGE_NAME)
	rm -rf distribution.xml finalDist.xml nmap.pkg ncat.pkg ndiff.pkg nping.pkg zenmap.pkg
	rm -f $(NMAP_TARBALL)

.PHONY: clean export-% stage-%

=== zenmap/install_scripts/windows/Makefile ===
export MSYS2_ARG_CONV_EXCL=""
MINGW_PREFIX=mingw-w64-x86_64
all: dist/zenmap-w64-deletelog.txt $(MINGW_PREFIX)-python-zenmap-*.pkg.tar.zst
	./build.sh

$(MINGW_PREFIX)-python-zenmap-%.pkg.tar.zst: PKGBUILD
	#pacman -Sy
	pacman -R --noconfirm $(MINGW_PREFIX)-python-zenmap || true
	makepkg-mingw -sfLi --noconfirm

dist/zenmap-w64-deletelog.txt: tmp.cfg mingw-w64-x86_64-python-zenmap-*.pkg.tar.zst
	styrene -p . -o $(dir $@) tmp.cfg --no-exe --no-zip

tmp.cfg: styrene.cfg ../utils/get_deps.py $(MINGW_PREFIX)-python-zenmap-*.pkg.tar.zst
	python3 ../utils/get_deps.py $@ $<

clean:
	rm -rf tmp.cfg pkg/ src/ dist/ mingw-w64-*-package.log* mingw-w64-*.zst

=== zenmap/zenmapCore/data/locale/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 TOPDIR = ../../..
 SOURCEFILES = zenmap
 SOURCEDIRS = zenmapCore zenmapGUI radialnet
-PROFILE_EDITOR_XML = share/zenmap/misc/profile_editor.xml
+PROFILE_EDITOR_XML = zenmapCore/data/misc/profile_editor.xml
 
 XGETTEXT = xgettext
 MSGID_BUGS_ADDRESS = dev@nmap.org

=== debian/rules ===
--- 
+++ 
@@ -1,13 +1,6 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-# mingw does not know about the arm64 specific cflag branch-protection
-# so strip it out of the build, so that the build doesn't fail.
-export DEB_CFLAGS_MAINT_STRIP = -mbranch-protection=standard
-
-ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
-	VENDOR_CONFIGURE_OPTIONS = --with-libssh2=included
-endif
 
 %:
 	dh $@

=== debian/watch ===
version=4
opts="uversionmangle=s/(beta|test)/~\\1/i,dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg,repack,compression=xz" \
    https://nmap.org/dist/nmap-(\d+\..*)\.tar.*
